#!/bin/sh
#
# Oreon is developped with Apache Licence 2.0 :
# http://www.apache.org/licenses/LICENSE-2.0.txt
# Developped by : Julien Mathis - Romain Le Merlus
#                 Christophe Coraboeuf - Mathieu Chateau

# The Software is provided to you AS IS and WITH ALL FAULTS.
# OREON makes no representation and gives no warranty whatsoever,
# whether express or implied, and without limitation, with regard to the quality,
# safety, contents, performance, merchantability, non-infringement or suitability for
# any particular or intended purpose of the Software found on the OREON web site.
# In no event will OREON be liable for any direct, indirect, punitive, special,
# incidental or consequential damages however they may arise and even if OREON has
# been previously advised of the possibility of such damages.

echo
echo "##########################################################################"
echo "#                     OREON Project (www.oreon.org)                      #"
echo "#                         Thanks for using OREON                         #"
echo "#                                                                        #"
echo "#                                v 1.2.3                                 #"
echo "#                                                                        #"
echo "#                            infos@oreon.org                             #"
echo "#                                                                        #"
echo "#                  Make sure you have installed and configured           #"
echo "#                             perl - sed                                 #"
echo "#                                                                        #"
echo "#                                                                        #"
echo "##########################################################################"
echo "#                              The Team OREON                            #"
echo "##########################################################################"
echo ""
echo ""
echo "                     Make sure you have root permissions !"
echo ""

echo "Are you sure to continue?"
echo -n "[y/n], default to [n]:"
read temp
if [ -z $temp ];then
    temp=n
fi

if [ $temp = "n" ];then
    echo "Bye bye !"
    exit
fi

test_answer()
{
    #$1 variable to fill
    #$2 text typed by user
    if [ ! -z $2 ];then
        if [ $2 != "" ];then
      eval $1=$2
        fi
    fi
}

##
## CONFIGURATION
##

echo ""
INSTALL_DIR_NAGIOS="/usr/local/nagios"
echo "Where is installed Nagios ?"
echo -n "default to [$INSTALL_DIR_NAGIOS]:"
read temp
test_answer INSTALL_DIR_NAGIOS $temp

echo ""

#nagios etc directory for oreon
NAGIOS_ETC="$INSTALL_DIR_NAGIOS/etc"
echo "Where are your nagios etc directory ?"
echo -n "default to [$NAGIOS_ETC]:"
read temp
test_answer NAGIOS_ETC $temp

echo ""

#nagios plugins directory for oreon
NAGIOS_PLUGIN="$INSTALL_DIR_NAGIOS/libexec"
echo "Where are your nagios plugin / libexec  directory ?"
echo -n "default to [$NAGIOS_PLUGIN]:"
read temp
test_answer NAGIOS_PLUGIN $temp

echo ""

#setup directory for oreon
INSTALL_DIR_OREON="/usr/local/oreon"
echo "Where do I install Oreon ?"
echo -n "default to [$INSTALL_DIR_OREON]:"
read temp
test_answer INSTALL_DIR_OREON $temp

echo ""

#RRDTOOL perl module directory
RRD_PERL="/usr/local/rrdtool/lib/perl"
echo "Where is RRD perl modules RRDs.pm ?"
echo -n "default to [$RRD_PERL]:"
read temp
test_answer RRD_PERL $temp



##
## VARIABLES
##
## Make sure you know what you do if you modify it !!

##
## INSTALL
##

if test -d $NAGIOS_PLUGIN ; then
    echo "Nagios libexec / plugins directory ... OK"
else
    mkdir -p $NAGIOS_PLUGIN > /dev/null
    echo "Nagios libexec / plugins directory ... OK"
fi

# check for httpd directory

if test -d /etc/apache/conf ; then
    DIR_APACHE="/etc/apache/conf"
    DIR_APACHE_CONF="/etc/apache/conf.d"
    HTPASSWD="htpasswd"
else if test -d /usr/local/apache2/conf ; then
    DIR_APACHE="/usr/local/apache2/conf"
    DIR_APACHE_CONF="/usr/local/apache2/conf"
    HTPASSWD="htpasswd"
else if test -d /etc/apache2 ; then
    DIR_APACHE="/etc/apache2"
    DIR_APACHE_CONF="/etc/apache2/conf.d"
    HTPASSWD="htpasswd2"
else if test -d /etc/httpd/conf ; then
    DIR_APACHE="/etc/httpd/conf"
    DIR_APACHE_CONF="/etc/httpd/conf.d"
    HTPASSWD="htpasswd"
fi
fi
fi
fi

if test -e $DIR_APACHE/apache2.conf ; then
    APACHE_CONF="apache2.conf"
else if test -e $DIR_APACHE/commondhttpd.conf ; then
    APACHE_CONF="commondhttpd.conf"
else if test -e $DIR_APACHE/httpd.conf ; then
    APACHE_CONF="httpd.conf"
fi
fi
fi


WEB_USER=`more $DIR_APACHE/$APACHE_CONF | grep ^User | cut -d " " -f 2`

if [ -z "$WEB_USER"  ] ; then
    for fichier in $DIR_APACHE/*
      do
      if [ -f "$fichier" ];	then
    WEB_USER_TEMP=`more $fichier | grep ^User | cut -d " " -f 2`
    if [ -n "$WEB_USER_TEMP" ]; then
        WEB_USER=$WEB_USER_TEMP
    fi
      fi
    done
fi




##
## FUNCTION
##

# Check the user and group nagios and create it if necessary

function check_user_nagios()
{
    nagios_user=`grep nagios /etc/passwd > /dev/null; echo $?`
    if [ $nagios_user == 0 ]; then
  echo "user nagios ... yes"
    else
  echo "user nagios ... no"
  useradd -g nagios nagios
  if [ $? == 0 ]; then
      echo "creating user nagios ... ok"
  else
      echo "error creating user nagios check you environnement ..."
      exit
  fi
    fi
}

function check_group_nagios()
{
    nagios_group=`grep nagios /etc/group > /dev/null; echo $?`
    if [ $nagios_group == 0 ]; then
  echo "group nagios ... yes"
    else
  echo "group nagios... no"
  groupadd nagios
  if [ $? == 0 ]; then
      echo "creating group nagios ... ok"
  else
      echo "error creating group nagios check you environnement ..."
      exit
  fi
    fi
}

function check_group_nagiocmd()
{
    nagios_group=`grep nagiocmd /etc/group > /dev/null; echo $?`
    if [ $nagios_group == 0 ]; then
  echo "group nagiocmd ... yes"
    else
  echo "group nagiocmd ... no"
  groupadd nagiocmd
  if [ $? == 0 ]; then
      echo "creating group nagiocmd ... ok"
  else
      echo "error creating group nagiocmd check you environnement ..."
      exit
  fi
    fi
}


# When exit on error

function error()
{
    echo "ERROR"
    exit 2
}

# install OREON PLUGIN

function confirm_oreon()
{

    	install_oreon

}

function install_oreon()
{
  echo "install oreon plugins..."

  # install plugins oreon

  if test -d $NAGIOS_PLUGIN ; then
      echo "$NAGIOS_PLUGIN already exists"
  else
      mkdir $NAGIOS_PLUGIN
      echo "$NAGIOS_PLUGIN created"
  fi
  echo "Preparing Oreon Plugins..."
  rm -f *.pl 2> /dev/null
  rm -f *.pm 2> /dev/null
  rm -f *.conf 2> /dev/null
  for fichier in src/*
      do
       filename=`echo $fichier  | sed -e 's|.*\/\(.*\)|\1|'`
       echo "	-> $filename"
       `sed -e 's|@INSTALL_DIR_NAGIOS@|'"$INSTALL_DIR_NAGIOS"'|g' -e 's|@NAGIOS_ETC@|'"$NAGIOS_ETC"'|g' -e 's|@NAGIOS_PLUGINS@|'"$NAGIOS_PLUGIN"'|g' -e 's|@RRDTOOL_PERL_LIB@|'"$RRD_PERL"'|g' -e 's|@INSTALL_DIR_OREON@|'"$INSTALL_DIR_OREON"'|g'  "$fichier" > "$filename"`
  done

  echo "Oreon Plugins Added on Nagios Plugins Directory"
  echo ""
  cp *.pl $NAGIOS_PLUGIN

  chown -R $WEB_USER:$WEB_USER $NAGIOS_PLUGIN
  chmod 775 $NAGIOS_PLUGIN/*

  cp oreon.conf $NAGIOS_PLUGIN
  chmod 775 $NAGIOS_PLUGIN/oreon.conf

  cp oreon.pm $NAGIOS_PLUGIN
  chmod 775 $NAGIOS_PLUGIN/oreon.pm

}

# installation script

check_group_nagios
check_user_nagios
check_group_nagiocmd
confirm_oreon

echo ""
echo ""
echo "##################################################"
echo "#                                                #"
echo "#        Report bugs at bugs@oreon.org           #"
echo "#                                                #"
echo "#           Thanks for using OREON.              #"
echo "#           -----------------------              #"
echo "#        Contact : infos@oreon.org               #"
echo "#          http://www.oreon.org                  #"
echo "##################################################"
